/* Adam Whitley
 * Sunday, April 14, 2013
 * For use in CSCI 181 and CSCI 182.
 * Driver class for a game of Blackjack.
 */
package blackjack;

public class Blackjack {
    static final int WINNING_LIMIT = 21;
    static final int STAND_VALUE = 17;
    

    public static void main(String[] args) {
        DeckOfCards deck = new DeckOfCards();
        deck.shuffle();

        // dealer's starting hand
        System.out.println("Let's play a hand of Blackjack!\nFirst, it's Dealer's turn.");
        BlackjackHand theDealer = new BlackjackHand(deck);
        System.out.println("Dealer begins with a hand of value " + theDealer.valueOfHand() + ":");
        theDealer.printHand();

        // dealer hits until he stands
        while (theDealer.valueOfHand() < STAND_VALUE) {
            if (theDealer.sizeOfHand() >= BlackjackHand.MAX_HAND_SIZE) { // 5 cards under 21: auto-win
                System.out.println("Dealer has drawn a hand of 5 cards, of value " + theDealer.valueOfHand() + ".  Automatic win!");
                theDealer.printHand();
                return;
            }
            theDealer.hitMe();
            System.out.println("Dealer draws a " + theDealer.mostRecentCard().name() + ", and now has " + theDealer.valueOfHand() + " points.");
        }

        // check to see if dealer busts
        if (theDealer.valueOfHand() > WINNING_LIMIT) {
            System.out.println("Dealer busts. Player 2 wins!");
            return;
        }

        System.out.println("Dealer stands with a hand of value " + theDealer.valueOfHand() + ":");
        theDealer.printHand();

        // player 2's starting hand
        System.out.println("Now, it's player 2's turn.");
        BlackjackHand player2 = new BlackjackHand(deck);
        System.out.println("Player 2 begins with a hand of value " + player2.valueOfHand() + ":");
        player2.printHand();

        // player 2 hits until he stands.  Beat the dealer's hand, or bust.
        while (player2.valueOfHand() < theDealer.valueOfHand()) {
            if (player2.sizeOfHand() >= BlackjackHand.MAX_HAND_SIZE) { // 5 cards under 21: auto-win
                System.out.println("Player 2 has drawn a hand of 5 cards, of value " + player2.valueOfHand() + ".  Automatic win!");
                player2.printHand();
                return;
            }
            player2.hitMe();
            System.out.println("Player 2 draws a " + player2.mostRecentCard().name() + ", and now has " + player2.valueOfHand() + " points.");
        }

        // check to see if Player 2 busts
        if (player2.valueOfHand() > WINNING_LIMIT) {
            System.out.println("Player 2 busts. Dealer wins!");
            return;
        }

        System.out.println("The hand is over.");
        System.out.println("Dealer's hand has value " + theDealer.valueOfHand() + ":");
        theDealer.printHand();
        System.out.println("Player 2's hand has value " + player2.valueOfHand() + ":");
        player2.printHand();

        // figure out who won
        if (theDealer.valueOfHand() >= player2.valueOfHand()) {
            System.out.println("Dealer wins!");
        } else {
            System.out.println("Player 2 wins!");
        }
    }//main
}//Blackjack
