/* Adam Whitley
 * Sunday, April 14, 2013
 * For use in CSCI 181 and CSCI 182.
 * This is the PlayingCard class for use in the Blackjack game.
 * Is uses a String full of lowercase characters for the suit.
 * It uses an int cardFace to store which card of the suit we have.
 *    cardFace 1 means Ace
 *    cardFace 2-10 means a number card
 *    cardFace 11 means Jack
 *    cardFace 12 means Queen
 *    cardFace 13 means King
 * NOTE: cardFace is NOT the same as the pointValue of the card!
 */
package blackjack;

public class PlayingCard {
    private String suit; // "clubs", "diamonds", "hearts" or "spades"
    private int cardFace; // the value on the card. 1 for ace, 2 for 2, 13 for king, etc

    // constructor
    public PlayingCard(int v, String s) {
        cardFace = v;
        suit = s;
    }
    
    // Is this card an Ace?
    boolean isAce() {
        if(cardFace == 1) {
            return true;
        } else {
            return false;
        }
    }
    // return the blackjack point value of this card
    public int pointValue() {
       if(cardFace > 10) {
           return 10;
       } else {
           return cardFace;
       }
    }
    
    // make a string of the name of the card
    public String name() {
        String temp = "";
        
        // concatenate the String equivalent of cardFace to temp
        if(cardFace == 1) {
            temp += "Ace";
        } else if(cardFace == 11) {
            temp += "Jack";
        } else if(cardFace == 12) {
            temp += "Queen";
        } else if(cardFace == 13) {
            temp += "King";
        } else { // a number card
            temp += cardFace; // implcit type conversion of cardFace into String
        }
        
        // concatenate the name together
        temp = temp + " of " + suit;
        return temp;
    }
}
